import de.bb.util.IntegerStack;

class Calc7 extends de.bb.bex.BnfLex
{
  IntegerStack operand  = new IntegerStack();
  IntegerStack operator = new IntegerStack();
  
  // hard coded nonterminal for numbers
  boolean isNumber()throws Exception
  {
    if (type != LX_INT)
      return false;
    next();
    return true;
  }
      
  // print result
  void print()
  {
    System.out.println(" = " + operand.pop());
  }
  
  // determine priority
  boolean hasHigherPriority(int oper, int prevOper)
  {
    // finish always calculation for current brackets
    if (prevOper == '(')
      return true;
    
    // lowest priority - previous does not care
    if (oper == '+' || oper == '-')
      return false;
    // medium
    if (oper == '*' || oper == '/')
      return prevOper == '+' || prevOper == '-';

    // highest priority - previos does not care
    return prevOper != '^';
  }

  void calculate()
  {    
    while (operand.size() > 1) // something to caclulate?
      doCalc();
  }
  
  void doCalc()
  {
    // return from a bracket block
    int oper = operator.pop();
    if (oper == '(')
      return;

    // now we have two operands on the operand stack
    int right = operand.pop();
    int result = 0;


    // and compare current operator with previous operator
    if (operator.size() > 0)
    {
      char prevOper = (char)operator.top();        
      if (!hasHigherPriority(oper, prevOper)) // evaluate left expression
        doCalc();
    }
      
    int left  = operand.pop();

    // perform calculation
    switch (oper)
    {
      case '+': result = left + right; break;
      case '-': result = left - right; break;
      case '*': result = left * right; break;
      case '/': result = left / right; break;
      case '^':
        result = 1;
        while (right-- > 0)
          result *= left;
        break;
    }

    // and push the result
    operand.push(result);
  }
}